TYPE RegType
     ax    AS INTEGER
     bx    AS INTEGER
     cx    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
END TYPE
DIM SHARED inreg AS RegType, outreg AS RegType
'
' Define the type needed for INTERUPTX
'
TYPE RegTypeX
     ax    AS INTEGER
     bx    AS INTEGER
     cx    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
     ds    AS INTEGER
     es    AS INTEGER
END TYPE
DIM SHARED inregx AS RegTypeX, outregx AS RegTypeX

'
'                 DECLARE statements for the 5 routines
'                 -------------------------------------
'
' Generate a software interrupt, loading all but the segment registers

'
DECLARE SUB INTERRUPT (intnum AS INTEGER, inreg AS RegType, outreg AS RegType)
'
' Generate a software interrupt, loading all registers
'
DECLARE SUB INTERRUPTX (intnum AS INTEGER, inreg AS RegTypeX, outreg AS RegTypeX)
'
' Call a routine at an absolute address.
' NOTE: If the routine called takes parameters, then they will have to
'       be added to this declare statement before the parameter given.
'
DECLARE SUB ABSOLUTE (address AS INTEGER)
'
' Generate a software interrupt, loading all but the segment registers
'       (old version)
'
DECLARE SUB INT86OLD (intnum AS INTEGER, inarray() AS INTEGER, outarray() AS INTEGER)
'
' Gemerate a software interrupt, loading all the registers
'       (old version)
'
DECLARE SUB INT86XOLD (intnum AS INTEGER, inarray() AS INTEGER, outarray() AS INTEGER)
'



DECLARE SUB PlayWaveVoice (Freq&)
DECLARE SUB LoadWaveVoice (WaveVoiceFile$)
DECLARE FUNCTION DSPVersion! ()
DECLARE FUNCTION SpeakerStatus% ()
DECLARE FUNCTION DMAStatus% ()
DECLARE FUNCTION DMADone% ()
DECLARE FUNCTION ResetDSP% ()
DECLARE FUNCTION ReadDSP% ()
DECLARE FUNCTION ReadDAC% ()

DECLARE SUB FMVolume (right%, left%, Getvol%)
DECLARE SUB VocVolume (right%, left%, Getvol%)
DECLARE SUB MasterVolume (right%, left%, Getvol%)
DECLARE SUB MicVolume (Gain%, Getvol%)
DECLARE SUB LineVolume (right%, left%, Getvol%)
DECLARE SUB CDVolume (right%, left%, Getvol%)
DECLARE SUB InputSource (InputSrc%, GetSrc%)
DECLARE SUB WriteDSP (byte%)
DECLARE SUB SetStereo (OnOff%)
DECLARE SUB WriteDAC (byte%)
DECLARE SUB SpeakerState (OnOff%)
DECLARE SUB DMAState (StopGo%)
DECLARE SUB DMAPlay (Segment&, Offset&, Length&, Freq&)
DECLARE SUB DMARecord (Segment&, Offset&, Length&, Freq&)
DECLARE SUB GetBLASTER (DMA%, BasePort%, IRQ%)
DECLARE SUB SetReg (Reg%, value%)

DECLARE SUB SBInit ()
DECLARE SUB PlayMusic ()
DECLARE SUB CloseChannels ()
DECLARE SUB SetIns (Channel%)
DECLARE SUB WriteReg (Reg%, value%)
DECLARE FUNCTION LoadJamFile% (File$)

DECLARE SUB Mouse (m1%, m2%, m3%, m4%)
DECLARE SUB ShowMouse ()
DECLARE SUB HideMouse ()
DECLARE FUNCTION MouseInRect% (x%, y%, x1%, y1%)


'$DYNAMIC

COMMON SHARED BasePort%, LenPort%, Channel%

CONST Baseaddr = &H220
CONST RegAddr = Baseaddr + 8, DataAddr = Baseaddr + 9
CONST MaxPlay% = -1

TYPE InsType
 MMult AS INTEGER
 MLevel AS INTEGER
 MAttack AS INTEGER
 MSustain AS INTEGER
 CMult AS INTEGER
 CLevel AS INTEGER
 CAttack AS INTEGER
 CSustain AS INTEGER
END TYPE

TYPE ChannelType
 Defined AS INTEGER
 Speed AS SINGLE
 SongPtr AS INTEGER
 PStat AS SINGLE
 Octave AS INTEGER
 WaveForm AS INTEGER
 Flag AS INTEGER
 Flag2 AS INTEGER
 IsPlaying AS INTEGER
 IsDone AS INTEGER
END TYPE

DIM SHARED MaxChannel%, MaxNotes%
DIM SHARED ChannelStat(1 TO 2) AS ChannelType
DIM SHARED Songbuf(1 TO 2) AS INTEGER
DIM SHARED CurrentIns AS InsType

DIM SHARED WaveBuffer(1) AS STRING * 32767
DIM SHARED WVLength AS LONG, WVFreq AS LONG
DIM SHARED LoadedWaveVoice AS STRING



